/* FineSlider.h		by Mike Gravina		December 1991
 * A subclass of Slider that allows Alternate key to slow slider 
 * down by scale factor
 *
 * Copyright (C)  1991  The Board of Trustees of
 * The Leland Stanford Junior University.  All Rights Reserved.
 */
 
#define FINESLIDER_H_ID "$Id: FineSlider.h,v 1.3 1991/12/24 11:11:16 pfkeb Rel $"

#import <appkit/Slider.h>

@interface FineSlider:Slider
{
    float		scaleFactor;	/* amount of slow down */
    float               centerValue;
    float               returnValue;
    float               offset;
    BOOL                inAltSequence;
}

- (float) floatValue;
 /*
  * Returns the value of the Slider.   If the Alternate key is held
  * down, then scales the normal response of a Slider by
  * the preset scale factor.
  */

- setScaleFactor:(float) aFloat;
 /*
  * Sets the scale factor to aFloat.
  */
  
@end
