#import "Graphic.h"

@interface Group : Graphic
{
    id cache;		/* an NXImage used to cache the group */
    id components;	/* the Graphics in the group */
    NXRect lastRect;	/* the last rectangle the group was drawn in */
    BOOL dontCache;	/* whether we can cache this group */
}

/* Creation methods */

- initList:list;
- free;

/* Public methods */

- transferSubGraphicsTo:list at:(int)position;

/* Methods overridden from superclass */

- setCacheable:(BOOL)flag;
- (BOOL)isCacheable;
- draw;
- (BOOL)hit:(const NXPoint *)point;

/* Compatibility methods */

- replaceWithImage;

/* Group must override all the setting routines to forward to components */

- makeGraphicsPerform:(SEL)aSelector with:(const void *)anArgument;

- changeFont:sender;
- font;
- setLineWidth:(const float *)value;
- setGray:(const float *)value;
- setFill:(int)mode;
- setFillColor:(NXColor *)aColor;
- setLineColor:(NXColor *)aColor;
- setLineCap:(int)capValue;
- setLineArrow:(int)arrowValue;
- setLineJoin:(int)joinValue;

/* Archiving methods */

- write:(NXTypedStream *)stream;
- read:(NXTypedStream *)stream;

@end
