/* InspectData.h		by Paul Kunz	December 1991
 * Controls binding of plot axes to ntuple columns.
 * 
 * Copyright (C)  1991  The Board of Trustees of
 * The Leland Stanford Junior University.  All Rights Reserved.
 */

#define INSPECTDATA_H_ID "$Id: InspectData.h,v 1.5 1992/03/27 21:32:32 pfkeb Rel $"

#import "InspectBase.h"

#import <dpsclient/event.h>
#import "hippo.h"

@interface InspectData:InspectBase
{
    id  tpBrowser;	/* NXBrowser showing tuple data titles */
    id 	tpBrowserCells;
    id  tpAxisForm;	/* Form to hold current axis labels */
    id  tpAxisButtons;	/* Matrix of Buttons to select axis */
	
    ntuple	selectedTuple;	/* current ntuple */
    
    int currentDim;	/* dimension of current plot */
    int tpAxisIndex[5];	/* index into tuple for each axis */
    graphtype_t         graphtype;
}

- initInspFor:aDraw;
 /*
  * Initializes inspector for global control object aDraw
  * Adds itself to Inspector Panel when done.
  */
  
- setButtonsAndTitles;
 /*
  * Enables appropriate axis buttons and titles
  */
 
- setTuple:(ntuple) atuple;
  /* Sets the tuple with already prepared display held by this object
   */

- showBinding;
 /*
  * Updates inspector view to show bindings of selected plot
  */
 
- tupleAxisChanged:sender;
  /* Responds to change in selected axis by restoring selected cell
   * in tuple Browser */
   
- (int) currentTupleCol;
  /* 
   * Returns current selected n-tuple column from NXBrowser
   */
   
- tupleSetAxisDataDim:sender;
  /* Responds to click in tuple Browser by setting the selected 
   * tuple data dimension to currently selected axis
   */
  
- updateView;
 /*
  * Updates the Inspector's content View.
  */

- (int) browser: sender fillMatrix: matrix inColumn: (int) column;
 /* delegate method of NXBrowser.   Will modify matrix and fill it with
  * tuple data 
  */
  
@end
