/* InspectPlot.h		by Paul Kunz	June 1991
 * Controls miscellaneous options of the Plot
 * 
 * Copyright (C)  1991  The Board of Trustees of
 * The Leland Stanford Junior University.  All Rights Reserved.
 */

#define INSPECTPLOT_H_ID "$Id: InspectPlot.h,v 1.23 1992/03/25 17:56:25 pfkeb Rel $"

#import "InspectBase.h"
#import <appkit/graphics.h>

#import "hippo.h"

@interface InspectPlot:InspectBase
{
    id	drawOptMatrix;	/* Matrix of drawing options */
    id	graphTypMatrix;	/* Matrix to select graph type */
    id  titleForm;	/* From for titles and labels */
    
    int currentDim;	/* dimension of current plot */
    graphtype_t         graphtype;
}

- initInspFor:aDraw;
 /* 
  * Initializes object and adds itself to the Inspector Panel's list.
  */
 
- drawOption:sender;
 /* 
  * Responds to change in Draw Options matrix
  */
 
- graphOption:sender;
 /*
  * Responds to change in Graph type options list
  */

- titleForm:sender;
 /*
  * Responds to ENTER in title and labels form by updating the
  * titles and lables for the selected Plots
  */
  
- resetTitle:sender;
 /*
  * Resets the title or label of a Plot.   Sender is a matrix of 
  * buttons.
  */
- updateView;
 /*
  * Update the Inspector's contents.
  */
  
@end
