/* InspectStat.h		by Paul Kunz	December 1991
 * Controls viewing of Statistics.
 * 
 * Copyright (C)  1991  The Board of Trustees of
 * The Leland Stanford Junior University.  All Rights Reserved.
 */

#define INSPECTSTAT_H_ID "$Id: InspectStat.h,v 1.4 1992/04/21 00:53:13 pfkeb Rel $"

#import "InspectBase.h"

@interface InspectStat:InspectBase
{
    id		statMatrix;	/* Matrix of under/in/over flows */
    id		statBox;	/* Box containing statistics */
}

- createImage:sender;
 /*
  * Creates an Image of the statistical matrix and inserts it on top
  * of the selected Plot
  */
  
- initInspFor:aDraw;
 /*
  * Initializes inspector for global control object aDraw
  * Adds itself to Inspector Panel when done.
  */
  
- clearStats;
 /*
  * Clears the statistics display in the inspector View
  */
  
- showStats;
 /*
  * Updates inspector view to show statistics of selected plot
  */
 
- updateView;
 /*
  * Updates the Inspector's content View.
  */
- updateEmptySelection;
 /*
  * Updates the Inspector's content View when there is no selection.
  */
@end
