#import <appkit/ScrollView.h>

typedef enum {
    LowerLeft = 0, LowerRight, UpperLeft, UpperRight
} RulerOrigin;

@interface SyncScrollView : ScrollView
{
    id hClipRuler;
    id vClipRuler;
    id rulerClass;
    NXCoord horizontalRulerWidth;
    NXCoord verticalRulerWidth;
    RulerOrigin rulerOrigin;
    BOOL verticalRulerIsVisible;
    BOOL horizontalRulerIsVisible;
    BOOL rulersMade;
}

/* Setting up the rulers */

- (BOOL)bothRulersAreVisible;
- (BOOL)eitherRulerIsVisible;
- (BOOL)verticalRulerIsVisible;
- (BOOL)horizontalRulerIsVisible;

- setRulerClass:factoryId;
- setRulerWidths:(NXCoord)horizontal :(NXCoord)vertical;
- setRulerOrigin:(RulerOrigin)origin;

- showHorizontalRuler:(BOOL)flag;
- showVerticalRuler:(BOOL)flag;

/* Comes up the responder chain to us */

- updateRulers:(const NXRect *)rect;
- showHideRulers:sender;

/* Overridden from superclass */

- reflectScroll:cView;
- tile;
- scrollClip:aClipView to:(const NXPoint *)aPoint;
- descendantFrameChanged:sender;

@end
