#import "Graphic.h"

@interface TextGraphic : Graphic
{
    char *data;			/* the rich text */
    int length;			/* the length of data */
    id font;
}

/* Factory methods overridden from superclass */

+ (BOOL)isEditable;
+ cursor;

/* Initialization method */

- init;

/* Factory method used to show/hide the ruler */

+ hideRuler:view;

/* Instance methods overridden from superclass */

- (BOOL)create:(NXEvent *)event in:view;
- (BOOL)edit:(NXEvent *)event in:view;
- draw;
- (BOOL)isOpaque;
- (BOOL)isValid;
- (NXColor)textColor;
- (NXColor)lineColor;
- (NXColor)fillColor;
- (BOOL)wantsTextColor;
- (BOOL)wantsLineColor;
- (BOOL)wantsFillColor;

- changeFont:sender;
- font;

/* Text delegate methods */

- textDidEnd:textObject endChar:(unsigned short)endChar;

/* Archiving methods */

- awake;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;

@end
