#ifndef _H_UTILITIES_H_
#define _H_UTILITIES_H_

/*
 * Functions to maintain and use the function registry.
 */
void *h_fNameSrch(const char *fname);
char *h_fPtrSrch(void *func);

/*
 * Set nice axis limits.
 */
void h_adjustAxis( float *low, float *high, int n_divisions, int log );

/*
 * error message functions
 */
void h_errmsg(const char *file, int line, const char *string );
#define h_error(x) h_errmsg(__FILE__,__LINE__,x)

int doCuts( float nt[], func_id cutlist );
int h_cut_lt( float nt[], double param[] );
int h_cut_gt( float nt[], double param[] );
int h_cut_le( float nt[], double param[] );
int h_cut_ge( float nt[], double param[] );
int h_cut_inside( float nt[], double param[] );
int h_cut_outside( float nt[], double param[] );
int h_cut_in_incl( float nt[], double param[] );
int h_cut_out_incl( float nt[], double param[] );

#endif				/* _H_UTILITIES_H_ */
