#ifndef _HSHRTNM_H_
#define _HSHRTNM_H_

/*
 * Set of short names for hippo routines.
 * Necessary for compilers that only generate external names
 * to 6 characters.
 */

/*
 * ntuple routines
 */
#define h_new            hNew
#define h_freeNt         hNfree
#define h_clrNt          hNclr
#define h_fill           hFill
#define h_arrayFill      hAfill
#define h_setNtTitle     hSNtit
#define h_setNtLabel     hSNLab
#define h_setAllNtLabels hSANLb
#define h_getNtLabel     hGNLab
#define h_getNtData      hGNDat
#define h_getNtColumn    hGNCol
#define h_arrayReplData  hRpDat
#define h_replData       hARpDt

#define h_fileParse      hParse
#define h_nt2text        hNt2Tx

/*
 * IO routines
 */
#define h_writeStream    hWrtSt
#define h_readStream     hRdSt
#define h_write          hWrite
#define h_read           hRead
#define h_readXDR        hRdXDR
#define h_writeXDR       hWtXDR
#define h_readMem        hRdMem
#define h_writeMem       hWtMem

/*
 * display routines
 */
#define h_plot           hPlot
#define h_setPlotDrvr    hSDrvr
#define h_fprint         hFPrnt
#define h_print(x) h_fprint(x,stdout)
#define h_newDisp        hDNew
#define h_freeDisp       hDFree
#define h_setDispDim     hSDDim
#define h_setDispType    hSDTyp
#define h_setDrawType    hSDrwT
#define h_orDrawType     hODrwT
#define h_bindNtuple     hBindN
#define h_bind           hBind
#define h_getBinding     hGBind
#define h_bindMany       hBindM
#define h_setBinWidth    hSBinW
#define h_getBinWidth    hGBinW
#define h_setBinNum      hSBinN
#define h_getBinNum      hGBinN
#define h_setColor       hSColr
#define h_setLogAxis     hSLogA
#define h_setRange       hSRang
#define h_getRange       hGRang
#define h_setTitle       hSDTit
#define h_setAxisLabel   hSALab
#define h_getAxisLabel   hGALab
#define h_bin            hBin
#define h_getBinExtreme  hGBinX
#define h_binVal         hBinVl
#define h_ptToBin        hPt2Bn
#define h_setDrawRect    hSDRct
#define h_setMarginRect  hSMRct
#define h_getDrawRect    hGDRct
#define h_setMargins     hGMRct
#define h_binWidth       hGBinW
#define h_wPtTogPt       hWp2Gp
#define h_gPtTowPt       hGp2Wp

#define h_func_reg       hFunRg
#define h_addCut         hAddCt
#define h_changeCut      hChgCt
#define h_addUserCut     hAdUCt
#define h_deleteCut      hDelCt
#define h_nextCut        hNxtCt
#define h_addPlotFunc    hAddPF
#define h_deletePlotFunc hDelPF
#define h_nextPlotFunc   hNxtPF

/*
 * utility routines
 */
#define h_errmsg         hErrMg
#define h_fNameSrch      hFnSch
#define h_fPtrSrch       hFpSch
#define h_adjustAxis     hAdjAx
#define h_expandLabel    hExpLb

#define h_cut_ge         hCutGe
#define h_cut_gt         hCutGt
#define h_cut_le         hCutLe
#define h_cut_lt         hCutLt
#define h_cut_inside     hCutIn
#define h_cut_outside    hCutOt
#define h_cut_in_incl    hCtInI
#define h_cut_out_incl   hCtOtI

/*
 * xdr routines
 */
#define xdr_rectangle    xRect
#define xdr_func_id_t    xFnIDT
#define xdr_func_id      xFncID
#define xdr_ntuple_t     xNt_t
#define xdr_ntuple       xNtupl
#define xdr_axis_t       xAxist
#define xdr_bind_strt_t  xBindt
#define xdr_display_t    xDispt
#define xdr_display      xDisp
#define xdr_hippo_rec    xHpRec
#define xdr_bins_t       xBinst


#endif				/* end of ifndef _HSHRTNM_H_ */
