
/* 

	EditController
	April 2
	
	This manages all zooming and edit-panel functions, and the selection and
	zoom windows.  

 */

#import <objc/Object.h>


@interface EditController:Object
{
	id	TheFileController;
	
	id  ZoomSlider;						// IO objects
	id  ZoomWindow;
	id  SelectionStart;
	id  SelectionEnd;
	id  SelectionLength;
	id  SelectionSecondsStart;				// selection in seconds
	id  SelectionSecondsEnd;
	id  SelectionSecondsLength;
	id  ViewStart;
	id  ViewEnd;
	id  ViewLength;
	id  ViewSecondsStart;
	id  ViewSecondsEnd;
	id  ViewSecondsLength;
	id  FortyButton;
	id  TwentyButton;
	id  MuLawButton;
	id  StereoButton;
	id  MonoButton;
	id  ConvertPasteBoardPanel;
	id  ZoomField;
	id EditButton;
	id ZoomButton;
	}

- Cut:sender;										// take a guess... :)
- PasteInto:sender;									// paste.
- Copy:sender;
- Delete:sender;
- SelectAll:sender;

- ZoomOut:sender;
- ZoomToSelection:sender;							/* Not yet Done */
- ZoomAllOut:sender;
- ZoomIn:sender;									// zoom in medium interval
- ZoomAllIn:sender;	
- ZoomSmallIn:sender;								// zoom in small interval
- ZoomLargeIn:sender;								// zoom in large interval
- ZoomSmallOut:sender;
- ZoomLargeOut:sender;
- ChangeZoom:sender;								// show zoom panel
- ZoomChanged:sender;								// redraw screen.

- TurnOnMenu:sender;								// turn edit menus on/off
- TurnOffMenu:sender;

- ChangeSelection:sender;
- ChangeView:sender;						// selection window to change
- ResetSelection:sender;						// reset selection window

- ConvertPasteBoard:sender;			// set up the convert pasteboard panel

- CompactSound:sender;				// compact the current sound

- SetContinuousZoom: (BOOL) ZoomOn;		// set the zoom to continuous/non-cont.


/*  IMPLEMENTED BY EDITCONTROLLER AS A DELEGATE OF PANELS */

- windowDidBecomeMain:sender;
- windowDidBecomeKey:sender;
- windowDidDeminiaturize:sender;

/*  IMPLEMENTED INTERNALLY.  DO NOT CALL */

- ZoomBy: (float) ThisZoomFactor;
- CancelConvertPasteBoard:sender;
- OkayConvertPasteBoard:sender;

@end
