
/*

The Sound Manager
March 25, 1992

The Sound Manager handles playing, recording, and stopping of sounds.  If you
want to make this program record nicely, fool around with the sound manager.
All objects call the Sound Manager to get the sounds to stop or to play them.

*/

#import <objc/Object.h>
#import "FileController.h"

@interface SoundManager:Object
{
    id  TheConsoleManager;
    id  TheFileController;
    id  TheEditController;
	
	
    id	CurrentSoundUsingDSP;
    id	CurrentSoundViewUsingDSP;
    id NewSound;
    BOOL Playing;
    BOOL  Recording;
}

- init;
- Stop:sender;
- Play:sender;
- Record: (int) SoundRate: (int) channels: (int) NumberOfSeconds: sender;
- CurrentSoundUsingDSP:sender;
- (BOOL) IsPlaying;						/* a sound is playing */
- (BOOL) IsRecording;



/*---IMPLEMENTED AS A DELEGATE OF SOUND AND SOUNDVIEW-----*/

- didPlay:sender;
- didRecord:sender;
- willPlay:sender;



/*-------IMPLEMENTED AS A DELEGATE OF SOUNDVIEW----------*/

- selectionChanged:sender;

@end
