.TH WAISINDEX 1 "Fri Sep 13 1991" "Thinking Machines"
.SH NAME
waisindex \- Indexes files
.SH SYNOPSIS
.B waisindex
[\ \-d\ index_filename\ ] [\ \-a\ ] [\ \-r\ ] [\ \-mem\ mbytes\ ] [\ \-register\ ] 
[\ \-t\ type\ ] [\ \-export\ ] filename filename ...
.SH DESCRIPTION
.PP
.B waisindex
creates an index of the words in files so that they can be searched quickly
(see waissearch).  The index takes about as much disk space as the original
text.  It also creates a new source structure named index_filename.src if none exists.
.SH OPTIONS
.PP
.TP 10
\fB\-d\fI index_filename
This is the base filename for the index files.  Therefore if /usr/local/foo
is specified, then the index files will be called /usr/local/foo.dct etc.
.br
The index should be stored on the local file system of the machine running
waisindex.  It works over NFS, but it is much slower.
.TP 10
.B \-a
Append this index to an existing one.  Useful for incremental additions or
updates.  This will only add onto an index, so that if a file has changed,
it will get reindexed, but the old entries will not be purged.  Therefore,
to save space, it is a good idea to reindex the whole set of files
periodically.
.TP 10
.B \-r
Recursively index subdirectories.
.TP 10
.B\-mem
How much main memory to use during indexing.  This variable will have a
large effect on how fast indexing is done.
.TP 10
.B \-register
Register this database with the directory of servers.  You are encouraged
to register databases, but only ones that will be consistently running.
The directory of servers is available to anyone that is on the internet or
can phone in.
.TP 10
\fB\-t\fI type
This is the format of files that are handled by waisindex.  It is easy to
parse a different format, but that has to be done by changing the source
(ircfiles.c).  To find out the list of currently known types, execute the
waisindex command with no arguments and it will list them.
.TP 10
\fB\-export
This causes the resulting source description file to include the host-name
and tcp-port for use by the clients.  Otherwise the file contains no
connection information, and is expected to be used only for local searches.

.SH SEE ALSO
waissearch(1), waisserver(1), waissearch-gmacs(1), xwais(1), xwaisq(1)
.PP
Wide Area Information Servers Concepts by Brewster Kahle.
.br
Brewster@think.com

.SH DIAGNOSTICS
.PP
The diagnostics produced by the waisindex is meant to be self-explanatory.

.SH BUGS
.PP
It temporarily takes twice the space it needs for an index.
