/* PControl.h  Copyright 1992 Steve Ludtke */

/* This object is basically just a switchboard for messages from various */
/* controls <-> views. It helps to simplify the Plot3DView object */

#import <objc/Object.h>
#import "Plot3DView.h"
#import <appkit/color.h>


@interface PControl:Object
{
id minX;		/* min/max coords for currently displayed region */
id maxX;
id minY;
id maxY;
id minZ;
id maxZ;
id symsel;		/* Symbol selector Matrix */
id colorSel;		/* NXColorWell to select symbol color */
id ffSel;		/* formula/file switch */
id equation;		/* ScrollView containing the equation */
id d3View;		/* Points to the Plot3DView object */
id dView;		/* Points to the DensView object */
id grid;		/* Selector for # points (x & y) */
int curPref;		/* Current data set displayed in the inspector */
SetPref *pref;		/* Data set preferences (& data pointers) */
}

/* Initialization */
-init;

/* Display preferences for selected data set. [[sender selectedCell] tag] */
/* is used to decide which set to display */
-disPref:sender;

/* Store preferences for current data set (OK button) */
-stoPref:sender;

/* Read a data file into a data set */
-readFile:sender;

/* Return a data set to equation mode */
-clearFile:sender;

/* Takes PControl min/max values and sends them to the Plot3DView */
-setMinMax:sender;

/* called by the Plot3DView to allow min/max Z values to be overrided */
/* and/or displayed */
-minmaxZ:(float *)minZ :(float *)maxZ;

/* zooms out by a fixed factor */
-zoomOut:sender;

/* zooms in by a fixed factor */
-zoomIn:sender;

/* This routine is called by the Plot3DView once after all the objects */
/* have been initialized. It passes the preferences array.*/
-startup:(SetPref *)Pref;

/* sets the PControl's max/min values */
-setMM:(float)minX :(float)maxX :(float)minY :(float)maxY;

/* receives the zoomTo messages from the DensView. Note that passed */
/* min/max values are from 0.0 to 1.0, not acutal units */
-zoomTo:(float)minx :(float)miny :(float)maxx :(float)maxy;

/* update density plot */
-updDen;
@end
